#! /usr/bin/env python

import os
import sys
import numpy
import csv

sys.path.append("/opt/Mantid/bin")
from mantid.simpleapi import *
cwd=os.getcwd()
config.setDataSearchDirs(cwd)
config['defaultsave.directory']=cwd

csvfile=sys.argv[1]
if len(sys.argv)>=3:
    nxsfile=sys.argv[2]
else:
    nxsfile='out'

tab = list(csv.reader(open(csvfile,'r')))
del tab[0:3]

ttab=[[tab[row][col] for row in range(len(tab))] for col in range(len(tab[0]))]

x=[]
y=[]
e=[]
for i in range(10):
    x.append(ttab[0])
    e.append([0 for _ in range(len(ttab[0]))])
y.append(ttab[9])
for i in range(8):
    y.append(ttab[i+1])
y.append(ttab[10])
xvalues=numpy.array(x)
yvalues=numpy.array(y)
evalues=numpy.array(e)

title=csvfile+' model - aclimax'
xunit = 'DeltaE_inWavenumber'
yunitlabel = 'Normalized intensity'

WS=CreateWorkspace(WorkspaceTitle=title,DataX=xvalues,DataY=yvalues,DataE=evalues,NSpec=yvalues.shape[0],UnitX=xunit,YUnitLabel=yunitlabel)
SaveNexusProcessed(InputWorkspace=WS,Filename=nxsfile+"-wavenumber.nxs")

# in meV
ttab[0]=[float(ttab[0][i])/8.0655 for i in range(len(ttab[0]))]
x=[]
for i in range(10):
	x.append(ttab[0])
xvalues=numpy.array(x)
xunit = 'DeltaE'
WS=CreateWorkspace(WorkspaceTitle=title,DataX=xvalues,DataY=yvalues,DataE=evalues,NSpec=yvalues.shape[0],UnitX=xunit,YUnitLabel=yunitlabel)
SaveNexusProcessed(InputWorkspace=WS,Filename=nxsfile+"-meV.nxs")
